
/*******************************************************************************
*
* File check6.c
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Check of the assignment programs assign_s2sb, ...
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "mpi.h"
#include "su3.h"
#include "start.h"
#include "misc.h"
#include "block.h"
#include "global.h"


static int cmp_s(spinor *r,spinor *s)
{
   float *rr,*rs,*rm;

   rr=(float*)(r);
   rs=(float*)(s);
   rm=rr+24;

   for (;rr<rm;rr++)
   {
      if ((*rr)!=(*rs))
         return 1;
      rs+=1;
   }

   return 0;
}


static int cmp_sd(spinor_dble *r,spinor_dble *s)
{
   double *rr,*rs,*rm;

   rr=(double*)(r);
   rs=(double*)(s);
   rm=rr+24;

   for (;rr<rm;rr++)
   {
      if ((*rr)!=(*rs))
         return 1;
      rs+=1;
   }

   return 0;
}


static int check_sb(block_t *b,ptset_t set,int l,int lb)
{
   int x0,x1,x2,x3,x[4],n0,n1;
   int y0,y1,y2,y3;
   int ix,iy,is;

   for (x0=0;x0<(*b).bs[0];x0++)
   {
      for (x1=0;x1<(*b).bs[1];x1++)
      {
         for (x2=0;x2<(*b).bs[2];x2++)
         {
            for (x3=0;x3<(*b).bs[3];x3++)
            {
               x[0]=x0;
               x[1]=x1;
               x[2]=x2;
               x[3]=x3;

               y0=(*b).bo[0]+x0;
               y1=(*b).bo[1]+x1;
               y2=(*b).bo[2]+x2;
               y3=(*b).bo[3]+x3;

               ix=ipt_blk(b,x);
               iy=ipt[y3+L3*y2+L2*L3*y1+L1*L2*L3*y0];
               is=(y0+y1+y2+y3)%2;

               n0=((is==0)&&((set==ALL_PTS)||(set==EVEN_PTS)));
               n1=((is==1)&&((set==ALL_PTS)||(set==ODD_PTS)));

               if (((n0==1)||(n1==1))&&
                     (cmp_s(&(*b).s[lb][ix],ps[l][iy])!=0))
                     return 1;
            }
         }
      }
   }

   return 0;
}


static int check_sdb(block_t *b,ptset_t set,int l,int lb)
{
   int x0,x1,x2,x3,x[4],n0,n1;
   int y0,y1,y2,y3;
   int ix,iy,is;

   for (x0=0;x0<(*b).bs[0];x0++)
   {
      for (x1=0;x1<(*b).bs[1];x1++)
      {
         for (x2=0;x2<(*b).bs[2];x2++)
         {
            for (x3=0;x3<(*b).bs[3];x3++)
            {
               x[0]=x0;
               x[1]=x1;
               x[2]=x2;
               x[3]=x3;

               y0=(*b).bo[0]+x0;
               y1=(*b).bo[1]+x1;
               y2=(*b).bo[2]+x2;
               y3=(*b).bo[3]+x3;

               ix=ipt_blk(b,x);
               iy=ipt[y3+L3*y2+L2*L3*y1+L1*L2*L3*y0];
               is=(y0+y1+y2+y3)%2;

               n0=((is==0)&&((set==ALL_PTS)||(set==EVEN_PTS)));
               n1=((is==1)&&((set==ALL_PTS)||(set==ODD_PTS)));

               if (((n0==1)||(n1==1))&&
                     (cmp_sd(&(*b).sd[lb][ix],psd[l][iy])!=0))
                  return 1;
            }
         }
      }
   }

   return 0;
}


static int check_sext(block_t *b,ptset_t set,int k,int l)
{
   int x0,x1,x2,x3;
   int y0,y1,y2,y3;
   int n0,n1,n2,n3,n4,n5;
   int ix,is;

   for (x0=0;x0<L0;x0++)
   {
      for (x1=0;x1<L1;x1++)
      {
         for (x2=0;x2<L2;x2++)
         {
            for (x3=0;x3<L3;x3++)
            {
               ix=ipt[x3+L3*x2+L2*L3*x1+L1*L2*L3*x0];
               is=(x0+x1+x2+x3)%2;

               y0=x0-(*b).bo[0];
               y1=x1-(*b).bo[1];
               y2=x2-(*b).bo[2];
               y3=x3-(*b).bo[3];

               n0=((y0<0)||(y0>=(*b).bs[0]));
               n1=((y1<0)||(y1>=(*b).bs[1]));
               n2=((y2<0)||(y2>=(*b).bs[2]));
               n3=((y3<0)||(y3>=(*b).bs[3]));

               n4=((is==0)&&(set!=EVEN_PTS)&&(set!=ALL_PTS));
               n5=((is==1)&&(set!=ODD_PTS)&&(set!=ALL_PTS));

               if ((n0==1)||(n1==1)||(n2==1)||(n3==1)||(n4==1)||(n5==1))
               {
                  if (cmp_s(ps[k][ix],ps[l][ix])!=0)
                     return 1;
               }
            }
         }
      }
   }

   return 0;
}


static int check_sbext(block_t *b,ptset_t set,int k,int l)
{
   int x0,x1,x2,x3;
   int n0,n1;
   int ix,is;

   for (x0=0;x0<(*b).bs[0];x0++)
   {
      for (x1=0;x1<(*b).bs[1];x1++)
      {
         for (x2=0;x2<(*b).bs[2];x2++)
         {
            for (x3=0;x3<(*b).bs[3];x3++)
            {
               ix=x0;
               ix=(*b).bs[1]*ix+x1;
               ix=(*b).bs[2]*ix+x2;
               ix=(*b).bs[3]*ix+x3;
               ix=(*b).ipt[ix];
               is=((*b).bo[0]+(*b).bo[1]+(*b).bo[2]+(*b).bo[3]+x0+x1+x2+x3)%2;

               n0=((is==0)&&(set!=EVEN_PTS)&&(set!=ALL_PTS));
               n1=((is==1)&&(set!=ODD_PTS)&&(set!=ALL_PTS));

               if ((n0==1)||(n1==1))
               {
                  if (cmp_s(&(*b).s[k][ix],&(*b).s[l][ix])!=0)
                     return 1;
               }
            }
         }
      }
   }

   return 0;
}


static int check_sdext(block_t *b,ptset_t set,int k,int l)
{
   int x0,x1,x2,x3;
   int y0,y1,y2,y3;
   int n0,n1,n2,n3,n4,n5;
   int ix,is;

   for (x0=0;x0<L0;x0++)
   {
      for (x1=0;x1<L1;x1++)
      {
         for (x2=0;x2<L2;x2++)
         {
            for (x3=0;x3<L3;x3++)
            {
               ix=ipt[x3+L3*x2+L2*L3*x1+L1*L2*L3*x0];
               is=(x0+x1+x2+x3)%2;

               y0=x0-(*b).bo[0];
               y1=x1-(*b).bo[1];
               y2=x2-(*b).bo[2];
               y3=x3-(*b).bo[3];

               n0=((y0<0)||(y0>=(*b).bs[0]));
               n1=((y1<0)||(y1>=(*b).bs[1]));
               n2=((y2<0)||(y2>=(*b).bs[2]));
               n3=((y3<0)||(y3>=(*b).bs[3]));

               n4=((is==0)&&(set!=EVEN_PTS)&&(set!=ALL_PTS));
               n5=((is==1)&&(set!=ODD_PTS)&&(set!=ALL_PTS));

               if ((n0==1)||(n1==1)||(n2==1)||(n3==1)||(n4==1)||(n5==1))
               {
                  if (cmp_sd(psd[k][ix],psd[l][ix])!=0)
                     return 1;
               }
            }
         }
      }
   }

   return 0;
}


static int check_sdbext(block_t *b,ptset_t set,int k,int l)
{
   int x0,x1,x2,x3;
   int n0,n1;
   int ix,is;

   for (x0=0;x0<(*b).bs[0];x0++)
   {
      for (x1=0;x1<(*b).bs[1];x1++)
      {
         for (x2=0;x2<(*b).bs[2];x2++)
         {
            for (x3=0;x3<(*b).bs[3];x3++)
            {
               ix=x0;
               ix=(*b).bs[1]*ix+x1;
               ix=(*b).bs[2]*ix+x2;
               ix=(*b).bs[3]*ix+x3;
               ix=(*b).ipt[ix];
               is=((*b).bo[0]+(*b).bo[1]+(*b).bo[2]+(*b).bo[3]+x0+x1+x2+x3)%2;

               n0=((is==0)&&(set!=EVEN_PTS)&&(set!=ALL_PTS));
               n1=((is==1)&&(set!=ODD_PTS)&&(set!=ALL_PTS));

               if ((n0==1)||(n1==1))
               {
                  if (cmp_sd(&(*b).sd[k][ix],&(*b).sd[l][ix])!=0)
                     return 1;
               }
            }
         }
      }
   }

   return 0;
}


int main(int argc,char *argv[])
{
   int my_rank,nb,isw;
   int n,k,l;
   int bs[4];
   ptset_t set;
   block_t *b;
   FILE *flog=NULL,*fin=NULL;

   MPI_Init(&argc,&argv);
   MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);

   if (my_rank==0)
   {
      flog=freopen("check6.log","w",stdout);
      fin=freopen("check6.in","r",stdin);

      printf("\n");
      printf("Check of the assignment programs assign_s2sb, ...\n");
      printf("-------------------------------------------------\n\n");

      printf("%dx%dx%dx%d lattice, ",NPROC0*L0,NPROC1*L1,NPROC2*L2,NPROC3*L3);
      printf("%dx%dx%dx%d process grid, ",NPROC0,NPROC1,NPROC2,NPROC3);
      printf("%dx%dx%dx%d local lattice\n\n",L0,L1,L2,L3);

      read_line("bs","%d %d %d %d",&bs[0],&bs[1],&bs[2],&bs[3]);
      fclose(fin);

      printf("bs = %d %d %d %d\n",bs[0],bs[1],bs[2],bs[3]);
   }

   MPI_Bcast(bs,4,MPI_INT,0,MPI_COMM_WORLD);

   start_ranlux(0,1234);
   geometry();
   alloc_s(2);
   alloc_sd(2);
   alloc_bgr(HMC_BLOCKS,bs);

   random_s(VOLUME,ps[0][0],0.1f);
   random_sd(VOLUME,psd[0][0],0.1);
   assign_s2s(VOLUME,ps[0][0],ps[1][0]);
   assign_sd2sd(VOLUME,psd[0][0],psd[1][0]);

   b=blk_list(HMC_BLOCKS,&nb,&isw);

   for (n=0;n<nb;n++)
   {
      for (set=0;set<=NO_PTS;set++)
      {
         k=((int)(set))%5;
         l=(k+1)%5;

         random_s((*b).vol,(*b).s[k],0.1f);
         assign_s2s((*b).vol,(*b).s[k],(*b).s[l]);
         assign_s2sb(b,set,0,k);
         error((check_sb(b,set,0,k)!=0)||(check_sext(b,ALL_PTS,0,1)!=0)||
               (check_sbext(b,set,k,l)!=0),1,
         "main [check6.c]","assign_s2sb is incorrect");

         random_s((*b).vol,(*b).s[k],0.1f);
         assign_s2s((*b).vol,(*b).s[k],(*b).s[l]);
         assign_sb2s(b,set,k,0);
         error((check_sb(b,set,0,k)!=0)||(check_sext(b,set,0,1)!=0)||
               (check_sbext(b,ALL_PTS,k,l)!=0),1,
         "main [check6.c]","assign_sb2s is incorrect");
         assign_sb2s(b,set,k,1);

         k=((int)(set))%3;
         l=(k+1)%3;

         random_sd((*b).vol,(*b).sd[k],0.1);
         assign_sd2sd((*b).vol,(*b).sd[k],(*b).sd[l]);
         assign_sd2sdb(b,set,0,k);
         error((check_sdb(b,set,0,k)!=0)||(check_sdext(b,ALL_PTS,0,1)!=0)||
               (check_sdbext(b,set,k,l)!=0),1,
         "main [check6.c]","assign_sd2sdb is incorrect");

         random_sd((*b).vol,(*b).sd[k],0.1);
         assign_sd2sd((*b).vol,(*b).sd[k],(*b).sd[l]);
         assign_sdb2sd(b,set,k,0);
         error((check_sdb(b,set,0,k)!=0)||(check_sdext(b,set,0,1)!=0)||
               (check_sdbext(b,ALL_PTS,k,l)!=0),1,
         "main [check6.c]","assign_sdb2sd is incorrect");
         assign_sdb2sd(b,set,k,1);
      }

      b+=1;
   }

   error_chk();

   if (my_rank==0)
   {
      printf("\n");
      printf("No errors detected --- all programs work correctly\n\n");
      fclose(flog);
   }

   MPI_Finalize();
   exit(0);
}
