
/*******************************************************************************
*
* File time3.c
*
* Copyright (C) 2005 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Timing of random_su2
*
*******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "random.h"

#define NLOOP 1000000

int main(void)
{
   int n;
   float rho,s[4];
   float t1,t2,dt;
   
   printf("\n");
   printf("Timing of random_su2\n");
   printf("--------------------\n\n");

   rlxs_init(0,23456);

   printf("Specify rho: ");
   scanf("%f",&rho);
   
   t1=(float)clock();
   for (n=0;n<NLOOP;n++)
      random_su2(rho,s);
   t2=(float)clock();

   dt=(t2-t1)/(float)(CLOCKS_PER_SEC);
   dt*=1.0e6f/(float)(NLOOP);

   printf("\n");
   printf("Average time per random SU(2) matrix : %4.3f micro sec\n\n",dt);
   exit(0);
}
